

function Create(obj, x, y)
	Rectangle(x, y, obj.defaults[1] or 30, obj.defaults[2] or 30, 'dynamic', obj.color, obj.texture, obj.dimentions[1] or 1, obj.dimentions[2] or 1, true, obj.density or 2, obj)
end

function Weld(box1, box2)
    local shp = {box1.fixture:getBody():getWorldPoints(box1.shape:getPoints())}
    box1.fixture:destroy()
    box1.shape:release()
	local body = box2.fixture:getBody()
    for i = 1, 4*2, 2 do
      shp[i], shp[i+1] = body:getLocalPoint(shp[i], shp[i+1])
    end
    box1.shape = love.physics.newPolygonShape(shp[1], shp[2], shp[3], shp[4],
      shp[5], shp[6], shp[7], shp[8])
    box1.fixture = love.physics.newFixture(body, box1.shape)
end


function love.load()
	inx = 0
	weldTo = {}
	zoom = {cam = 1}
	build = false
	collisions = 0
	jumpcolls = 0
	objects = {}
	secs = 0
	grounded = true
	setg = true
	walk = false
	love.physics.setMeter(64)
	world = love.physics.newWorld(0, 15.50*64, false)
	world:setCallbacks(beginContact, endContact, preSolve, postSolve)
	love.window.setMode(650, 650)


	collide_all = 1
	selectable = 2
	collide_selection = 3
	collide_player = 4
	
	ground = Rectangle(650/2, 650/2 + 400, 650, 200, 'static', {1, 1, 1})
	cubeA = Rectangle(650/2, 650/2, 50, 50, 'dynamic', {1, 1, 1})
	cubeB = Rectangle(650/2 + 25, 650/2 + 50, 50, 50, 'dynamic', {1, 1, 1})
end


function Rectangle(x, y, w, h, bodytype, color, image, sx, sy, tx, d, part)
	block = {}
	block.body = love.physics.newBody(world, x, y, bodytype)
	block.shape = love.physics.newRectangleShape(w, h)
	block.color = color
	block.fixture = love.physics.newFixture(block.body, block.shape, d or 2)
	block.image = image or nil
	block.sx = sx
	block.sy = sy
	block.welds = {}
	block.w = w
	block.h = h
	block.type = part
	if tx == true then
		block.quad = love.graphics.newQuad(0, 0, w, h, image:getWidth(), image:getHeight())
		image:setWrap("repeat", "repeat")
	end
	table.insert(objects, block)
	block.fixture:setCategory(collide_all, selectable)
	return block
end

function pair(ptable, element, suffix)
	if ptable == {} then return false end
	if suffix then
		for i, v in pairs(ptable) do
			if v[suffix] == element then
				return i
			end
		end
	else
		for i, v in pairs(ptable) do
			if v == element then
				return i
			end
		end
	end
	return false
end

function love.update(dt)
	world:update(dt)
end





function love.keypressed(key, code, isrep)
	if key == "e" then
		Weld(cubeA, cubeB)
	end
end




function love.draw()	

	for i, v in pairs(objects) do
		tx, ty, bx, by = v.fixture:getBoundingBox()
		xx = (tx + bx) / 2
		yy = (ty + by) / 2
		rotation = 0 -- math.atan((tx - bx), (ty - by))
		love.graphics.setColor(v.color)
		if v.fixture:isSensor() == false then 
			if v.image == nil then
				love.graphics.rectangle('fill', xx, yy, v.w, v.h)
			end
		end
		love.graphics.points(xx, yy)
	end
	

	love.graphics.print('Press E to connect the bodies.' .. '\n' .. 'This version appears to work, but it uses fixture:getBoundingBox() to find the position of fixtures' .. '\n' .. 'which does not support rotation.',  20, 20)
end
